/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 INRIA
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <iostream>
#include "ns3/abort.h"
#include "ns3/assert.h"
#include "ns3/log.h"
#include "ns3/header.h"
#include "etherip-header.h"

NS_LOG_COMPONENT_DEFINE ("EtheripHeader");

namespace ns3 {

NS_OBJECT_ENSURE_REGISTERED (EtheripHeader);

EtheripHeader::EtheripHeader ()
{
}

EtheripHeader::~EtheripHeader ()
{
}

  TypeId 
EtheripHeader::GetTypeId (void)
{
  static TypeId tid = TypeId ("ns3::EtheripHeader")
    .SetParent<Header> ()
    .AddConstructor<EtheripHeader> ()
    ;
  return tid;
}

  TypeId 
EtheripHeader::GetInstanceTypeId (void) const
{
  return GetTypeId ();
}

void 
EtheripHeader::Print (std::ostream &os) const
{}

uint32_t
EtheripHeader::GetSerializedSize (void) const
{
  return 2;
}

void
EtheripHeader::Serialize (Buffer::Iterator start) const
{
  uint16_t header = 0x3;
  start.WriteHtonU16 (header);
}

uint32_t
EtheripHeader::Deserialize (Buffer::Iterator start)
{
  uint16_t header;
  header = start.ReadNtohU16 ();
  NS_ASSERT (header == 0x3);
  return GetSerializedSize();
}


} // namespace ns3
