/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2010 INRIA
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef ETHERIP_HEADER_H
#define ETHERIP_HEADER_H

#include "ns3/header.h"

namespace ns3 {

/**
 * \brief Packet header for ETHERIP
 *
 * See rfc 3378
 */
class EtheripHeader : public Header 
{
public:

  /**
   * \brief Construct a ETHERIP header.
   */
  EtheripHeader ();

  /**
   * \brief Destroy a ETHERIP header.
   */
  virtual ~EtheripHeader ();

  static TypeId GetTypeId (void);
  virtual TypeId GetInstanceTypeId (void) const;
  virtual void Print (std::ostream &os) const;
  virtual void Serialize (Buffer::Iterator start) const;
  virtual uint32_t Deserialize (Buffer::Iterator start);
  virtual uint32_t GetSerializedSize (void) const;

};

}; // namespace ns3


#endif /* ETHERIP_HEADER_H */
